#include "bit.h"
#include <iostream>
using namespace std;

char GetNonSpaceCharacter() {

  char ret;
  while (1) {
    cin >> ret;
    if (ret != ' ')
      return ret;
  }

}

BIT::BIT(BIT *_parent) {

  char currChar;

  parent = _parent;

  currChar = GetNonSpaceCharacter();
  if (currChar == '(') {
    left = new BIT(this);
    opr = GetNonSpaceCharacter();
    right = new BIT(this);
    currChar = GetNonSpaceCharacter();
  }
  else if (currChar == '-') {
    currChar = GetNonSpaceCharacter();
    opd = '0' - currChar;
    left = right = NULL;
  }
  else {
    opd = currChar - '0';
    left = right = NULL;
  }

}

int BIT::Eval() {

  if (left == NULL) {
    return opd;
  }
  int leftValue = left->Eval();
  int rightValue = right->Eval();

  switch (opr) {
  case '+': return leftValue + rightValue;
  case '-': return leftValue - rightValue;
  case '/': return leftValue / rightValue;
  case '*': return leftValue * rightValue;
  default:
    return 0;
  }

  return 0;

}


/*-------------------------*/

void BIT::SetRow(int currDepth) {

  row = currDepth;
  if (left) {
    left->SetRow(currDepth+1);
    right->SetRow(currDepth+1);
  }
}

void BIT::SetColumn(int& cir) {

  if (!left) {
    column = cir;
    cir++;
    return;
  }
  left->SetColumn(cir);
  column = cir;
  cir++;
  right->SetColumn(cir);

}

void BIT::Draw(Image *image) {

  if (!left) {
    if (opd < 0) {
      image->SetPixelIfInsideFrame(row, column*2, '-');
      image->SetPixelIfInsideFrame(row, column*2+1, '0'-opd);
    }
    else {
      image->SetPixelIfInsideFrame(row, column*2, '0'+opd);
    }
    return;
  }
  
  image->SetPixelIfInsideFrame(row, left->column+right->column, opr);
  left->Draw(image);
  right->Draw(image);

}