#include "v2d.h"
#include "math.h"

V2D V2D::operator+(V2D &secondOperand) {
  
  V2D ret;
  ret.xy[0] = xy[0] + secondOperand.xy[0];
  ret.xy[1] = xy[1] + secondOperand.xy[1];
  return ret;

}

V2D V2D::operator-(V2D &secondOperand) {
  
  V2D ret;
  ret.xy[0] = xy[0] - secondOperand.xy[0];
  ret.xy[1] = xy[1] - secondOperand.xy[1];
  return ret;

}

V2D V2D::operator/(float secondOperand) {

  V2D ret;
  ret.xy[0] = xy[0] / secondOperand;
  ret.xy[1] = xy[1] / secondOperand;
  return ret;

}

V2D V2D::operator*(float secondOperand) {

  V2D ret;
  ret.xy[0] = xy[0] * secondOperand;
  ret.xy[1] = xy[1] * secondOperand;
  return ret;

}

float& V2D::operator[](int i) {

  return xy[i];

}

void V2D::SetItsPixel(Image &image, Color &color) {
  image.SetPixelIfInsideFrame((int)xy[0], (int)xy[1], color);
}

void V2D::RasterizeSquare(Image &image, int squareSize, Color &color) {
	int ri, ci;
	for (ri=xy[0]; ri<xy[0]+squareSize; ri++)
		for (ci=xy[1]; ci<xy[1]+squareSize; ci++) 
			image[ri][ci] = color;
}

float V2D::Length() {

  return sqrtf(xy[0]*xy[0]+xy[1]*xy[1]);

}

istream& operator>>(istream &istr, V2D& v2d) {

  istr >> v2d.xy[0] >> v2d.xy[1];
  return istr;

}

