#ifndef V2D_H_
#define V2D_H_

#include "image.h"

class V2D {
  float xy[2];
public:
  // constructors
  V2D(float *_xy);
  V2D(float x, float y) {xy[0]=x; xy[1]=y;};
  V2D() {xy[0]=0; xy[1]=0;};
  // operators
  float& operator[](int i);
  V2D operator+(V2D &secondOperand);
  V2D operator-(V2D &secondOperand);
  V2D operator*(V2D &secondOperand); // dot product
  V2D operator*(float secondOperand); // multiplication with scalar
  V2D operator/(float secondOperand); // division with scalar
  friend istream& operator>>(istream &istr, V2D& v2d);
  // drawing
  void RasterizeSquare(Image &image, int squareSize, Color &color);
  void SetItsPixel(Image &image, Color &color);
  void RasterizeDiagonalCross(Image &image, int crossSize, Color &color);
  // other methods
  V2D GetPerpendicular(); // return perpendicular vector (rotated -90 degrees (i.e. 90 degrees clockwise))
  float Length(); // euclidian distance from origin
  V2D Normalized(); // return normalized
  void Normalize(); // normalize this vector
};

#endif